#include<bits/stdc++.h>
using namespace std;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    string s;
    vector<vector<int>> toxic;

    for(int i = 0;i < n;i++) cin >> s;

    for(int i = 0;i < n;i++){
        vector<int> L;
        for(int j =0;j < n;i++){
            int x;
            cin >> x;
            L.push_back(x);
        }
        toxic.push_back(L);
    }

    for(int i = 1;i < n;i++){
        toxic[0][i] += toxic[0][i-1];
    }
    for(int i = 1;i < n;i++){
        toxic[i][0] += toxic[i-1][0];
    }
    for(int i = 1;i < n;i++){
        for(int j =1;j < n;j++){
            toxic[i][j] += min(toxic[i-1][j], toxic[i][j-1]);
        }
    }
    cout << toxic[n-1][n-1];
    return 0;
}